package com.ekexiu.logSystem.job;

import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

import org.jfw.util.bean.AfterBeanFactory;
import org.jfw.util.bean.BeanFactory;
import org.jfw.util.context.JfwAppContext;

import com.ekexiu.logSystem.handler.LogHandler;
import com.ekexiu.logSystem.service.Main;
import com.ekexiu.logSystem.service.TemplateService;

public class TaskJob implements AfterBeanFactory {
	@Override
	public void handle(BeanFactory bf) throws Throwable {
		Main main = (Main) bf.getBean("com_ekexiu_logSystem_service_Main");
		ScheduledExecutorService service = JfwAppContext.getScheduledExecutorService();
		for (LogHandler lh : main.getHandlers()) {
			service.scheduleAtFixedRate(lh, lh.getInitialDelay(), lh.getPeriod(), TimeUnit.MILLISECONDS);
			JfwAppContext.addDestoryed(lh);
		}

		final TemplateService templateService = (TemplateService) bf.getBean("com_ekexiu_logSystem_service_TemplateService");
		service.scheduleAtFixedRate(new Runnable() {
			@Override
			public void run() {
				templateService.handle();
			}
		}, 0, 10, TimeUnit.SECONDS);
	}
}
