package com.ekexiu.logSystem.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;
import java.util.Map;

import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.method.Jsonp;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.ParameterMap;

import com.ekexiu.logSystem.dao.DayDao;
import com.ekexiu.logSystem.handler.LogHandler;
import com.ekexiu.logSystem.pojo.DayData;

@Path
public class Main {
	public static final String MAX_DAY="99999999";
	public static final String MIN_DAY="00000000";
	

	private List<LogHandler> handlers;

	private DayDao dayDao = new DayDao();

	public List<LogHandler> getHandlers() {
		return handlers;
	}

	public void setHandlers(List<LogHandler> handlers) {
		this.handlers = handlers;
	}

	@Get
	@Jsonp
	@Path("/log")
	public void log(@ParameterMap Map<String, String[]> pm) {
		for (LogHandler lh : this.handlers) {
			lh.add(pm);
		}
	}

	@Get
	@Jsonp
	@Path("/qm")
	public List<DayData> query(@JdbcConn Connection con, String tn, @Nullable String[] src, @Nullable String[] id, @DefaultValue("com.ekexiu.logSystem.service.Main.MIN_DAY") String bt,
			@DefaultValue("com.ekexiu.logSystem.service.Main.MAX_DAY") String et, @Nullable String sort) throws SQLException {
		return dayDao.query(con, tn, src, id, bt, et, sort);
	}
	@Get
	@Jsonp
	@Path("/qo")
	public List<DayData> query(@JdbcConn Connection con, String tn, String id, @DefaultValue("com.ekexiu.logSystem.service.Main.MIN_DAY") String bt,
			@DefaultValue("com.ekexiu.logSystem.service.Main.MAX_DAY") String et) throws SQLException {
		return dayDao.query(con, tn,  id, bt, et);
	}
	@Get
	@Jsonp
	@Path("/qs")
	public List<DayData> query(@JdbcConn Connection con, String tn,@Nullable String[] src, @DefaultValue("com.ekexiu.logSystem.service.Main.MIN_DAY") String bt,
			@DefaultValue("com.ekexiu.logSystem.service.Main.MAX_DAY") String et,@DefaultValue("20") int rows) throws SQLException {
		return dayDao.query(con, tn, bt, et,src,rows);
	}
	
}
